﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;

namespace Service
{
    [ServiceContract(Name = "SampleMethodContract", 
        Namespace = "http://wangweimutou.SampleMethodContract", 
        SessionMode=SessionMode.Required)]
    public interface ISampleMethod
    {
        /// <summary>
        /// IsInitiating默认值为true，IsTerminating默认值为false
        /// </summary>
        /// <param name="msg"></param>
        [OperationContract(Name="OCMethodOne",
            AsyncPattern=false,
            IsInitiating=true,
            IsTerminating=false,
            Action = "http://wangweimutou.SampleMethodContract/RequestMethodOne",
            ReplyAction = "http://wangweimutou.SampleMethodContract/ResponseMethodOne")]
        string MethodOne(string msg);

       [OperationContract(Name = "OCMethodTwo",
            AsyncPattern = false,
            IsInitiating = true,
            IsTerminating = false,
            Action = "http://wangweimutou.SampleMethodContract/RequestMethodTwo",
            ReplyAction = "http://wangweimutou.SampleMethodContract/ResponseMethodTwo")]
        string MethodTwo(string msg);


         [OperationContract(Name = "OCMethodThree",
            AsyncPattern = true,
            IsInitiating = true,
            IsTerminating = false,
            Action = "http://wangweimutou.SampleMethodContract/RequestMethodThree",
            ReplyAction = "http://wangweimutou.SampleMethodContract/ResponseMethodThree")]
          IAsyncResult BeginMethodThree(string msg, AsyncCallback callback, object asyncState);
          string EndMethodThree(IAsyncResult result);
    }
}
