﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.ServiceModel;

namespace Service
{  
    public class SampleMethod :ISampleMethod
    {
        public string MethodOne(string msg)
        {
            return "You called MethodOne return message is: " + msg;
        }

        public string MethodTwo(string msg)
        {
            return "You called MethodTwo return message is: " + msg;
        }


        public IAsyncResult BeginMethodThree(string msg, AsyncCallback callback, object asyncState)
        {
            return new CompletedAsyncResult<string>(msg);
        }

        public string EndMethodThree(IAsyncResult r)
        {
            CompletedAsyncResult<string> result = r as CompletedAsyncResult<string>;
            return "You called MethodThree return message is: " + result.Data;
        }
    }

    class CompletedAsyncResult<T> : IAsyncResult
    {
        T data;

        public CompletedAsyncResult(T data)
        { this.data = data; }

        public T Data
        { get { return data; } }

        #region IAsyncResult Members
        public object AsyncState
        { get { return (object)data; } }

        public WaitHandle AsyncWaitHandle
        { get { throw new Exception("The method or operation is not implemented."); } }

        public bool CompletedSynchronously
        { get { return true; } }

        public bool IsCompleted
        { get { return true; } }
        #endregion
    }
}
